//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "PACSDK.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
HANDLE hPort ;
void __fastcall TForm1::btnOpenComClick(TObject *Sender)
{
      char strErr[32] ;
      hPort = uart_Open("");
      if(hPort == INVALID_HANDLE_VALUE)
      {
                pac_GetErrorMessage(pac_GetLastError(), strErr);
                MessageBox(NULL,strErr,"Open COM error",MB_OK);
      }
      else
      {
                btnOpenCom->Enabled =false;
                btnCloseCom->Enabled =true;
      }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnCloseComClick(TObject *Sender)
{
        uart_Close(hPort);
        btnOpenCom->Enabled =true;
        btnCloseCom->Enabled =false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnSendCmdClick(TObject *Sender)
{
        char cRes[64];
        //change slot
        pac_ChangeSlot(cmbSlot->ItemIndex +1);
        //Send command
        uart_SendCmd(hPort,etCmd->Text.c_str() ,cRes);
        //Show response
        etResponse->Text =AnsiString(cRes);
}
//---------------------------------------------------------------------------

