//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "PACSDK.h"
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
HANDLE hPort ;
void __fastcall TForm1::btnOpenComClick(TObject *Sender)
{
        char strErr[32] ;
        hPort=uart_Open(etComFormat->Text.c_str() );
        if(hPort == INVALID_HANDLE_VALUE)
        {
                pac_GetErrorMessage(pac_GetLastError(), strErr);
                MessageBox(NULL,strErr,"Open COM error",MB_OK);
        }
        else
        {
                btnOpenCom->Enabled =false;
                btnCloseCom->Enabled =true;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnSendCmdClick(TObject *Sender)
{
        char Res[20];
        memset(Res,0,sizeof(Res));
        bool bRet=uart_SendCmd(hPort,etCmd->Text .c_str(), Res);
        if(bRet!= false)
        {
                etRes->Text=StrPas(Res);
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnCloseComClick(TObject *Sender)
{
        uart_Close(hPort);
        btnOpenCom->Enabled =true;
        btnCloseCom->Enabled =false;
}
//---------------------------------------------------------------------------
